]> rtime.felk.cvut.cz Git - can-benchmark.git/blobdiff - gw-tests/lib.sh
Test for -rt kernel in highptio test
[can-benchmark.git] / gw-tests / lib.sh
index a20f791a03b344b96716483b7eb35463baf52329..14038cd7c0d8b871b7d56e21e0228d36d953d5ed 100644 (file)
 set -e
 
+COUNT=10000
+
+OPT_TRAFFIC=oneatatime
+
+error() {
+    echo $1 >&2
+    exit 1
+}
+
 while [ $# -gt 0 ]; do
     case "$1" in
-       -P) OPT_PLOT_DISABLE=1; shift;;
-       -p) OPT_PLOT_ONLY=1; shift;;
+       -P|--no-plot) OPT_PLOT_DISABLE=1; shift;;
+       -p|--plot) OPT_PLOT_ONLY=1; shift;;
        -X|--no-x11-plot) OPT_NO_X11=1; shift;;
+       -t) case "$2" in
+               all|flood|50|oneatatime) OPT_TRAFFIC=$2;;
+               *) error "Unknown traffic specification: $2";;
+           esac;
+           shift 2;;
     esac
 done
 
 PATH=$PWD/../_compiled/bin/:$PATH
 
-COUNT=10000
-
-error() {
-    echo $1 >&2
-    exit 1
-}
-
 sshgw() {
     local socket="$HOME/.ssh/cangw-connection"
 
-    if [[ ! -S $socket ]]; then
-        # Create master connection to speed up subsequenct command.
-        # The ssh is put into background and the connection is closed
-        # after 10 minutes)
+    if [[ ! -S $socket ]] || ! ssh -x -a -S $socket root@192.168.2.3 true; then
+       # Create master connection to speed up subsequenct command.
+       # The ssh is put into background and the connection is closed
+       # after 10 minutes)
        ssh -f -M -S $socket root@192.168.2.3 sleep 600 > /dev/null 2>&1
     fi
     ssh -x -a -S $socket root@192.168.2.3 "$@"
 }
 
-_cleanupgw() {
-    # Set can interfaces up
-    sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
-    # Delete all GW rules
-    sshgw 'eval $(cangw -L|sed -e s/-A/-D/ -e "s/#.*/;/")'
+cleanupgw() {
+    sshgw 'cangw -F'
 }
 
 _plot() {
     local testname=`basename $0 .sh`
 
-    cmd=$(plot_cmds)                   # Get plot commands
-    cmd=$(echo "$cmd" | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n($kvers)\"/")
+    plot_cmds | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n(GW kernel $kvers, traffic $traffic)\"/" > plot.gp
+    if [[ ! -s plot.gp ]]; then return; fi
     if [ -z "$OPT_NO_X11" ]; then
-       echo "set terminal x11 enhanced; ${cmd}" | gnuplot -persist
+       echo "set terminal x11 enhanced; $(< plot.gp)" | gnuplot -persist
     fi
     I=''
     echo 'set terminal postscript color eps enhanced size 6cm,4cm lw 1 "Times-Roman" 10;' \
        'set lmargin 8;' \
-       "${cmd}" | gnuplot > ${testname}$I.eps
+       "$(< plot.gp)" | gnuplot > ${testname}$I.eps
     echo "set terminal postscript color eps enhanced;" \
-       "${cmd}" | gnuplot | epstopdf --filter > ${testname}$I.pdf
+       "$(< plot.gp)" | gnuplot | epstopdf --filter > ${testname}$I.pdf
     mkdir -p thumb
     convert -density 30  -gamma 0.5 -quality 90 -type Palette -depth 8 ${testname}$I.pdf thumb/${testname}$I.png
     convert -density 150 -gamma 0.7 -quality 90 -type Palette -depth 8 ${testname}$I.pdf ${testname}$I.png
 
 }
 
-create_dirs_and_links() {
-    local test=$1
-    local kver=$2
+echo_plot() {
+    plot=$1
+    [[ "$_plot_separator" ]] && echo ", \\"
+    _plot_separator=t
+    echo -n "    " $plot
+}
 
-    local  d=results/by-kern/$kver/$test
-    mkdir -p $d
-    mkdir -p results/by-test/$test
-    ln -sfT ../../${d#results/} results/by-test/$test/$kver
-    echo $d
+traffic_and_length() {
+    local opts
+    case $traffic in
+       flood) opts='';;
+       50)        opts="-p $((2*(44+$1*8)))";;
+       oneatatime)        opts="-o";;
+       *) error "Unknown traffic specification"
+    esac
+    echo $opts -l $1
 }
 
-_run() {
-    _cleanupgw
-    kvers=$(sshgw uname -r)
-    dir=$(create_dirs_and_links $(basename $0 .sh) $kvers)
-    cd $dir
+_measure() {
+    # Remove data from the last measurement
+    rm -rf *
+    touch .results
+    cat > plot.sh <<-EOF
+       #!/bin/bash
+       export kvers=$kvers
+       export hostkvers=$hostkvers
+       export traffic=$traffic
+       cd \$(dirname \$0)/$(dirname $script)
+       exec ./$(basename $script) --plot "\$@"
+       EOF
+    chmod +x plot.sh
+    # Set can interfaces up
+    sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
+    # Delete all vcan interfaces
+    sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
+    # Reset priorities
+    sshgw 'if pid=`pidof irq/145-can0`; then chrt -p -f 50 $pid > /dev/null; fi'
+    sshgw 'if pid=`pidof irq/146-can1`; then chrt -p -f 50 $pid > /dev/null; fi'
+    sshgw 'if pid=`pidof sirq-net-rx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
+    sshgw 'if pid=`pidof sirq-net-tx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
+    # Set the length of qdisc queue to avoid ENOBUFS errors
+    ifconfig can0 txqueuelen 200
+    cleanupgw
+    
     main
-    _plot
+}
+
+
+_run() {
+    if [[ $OPT_TRAFFIC = all ]]
+    then traffics="flood 50 oneatatime"
+    else traffics=${traffic:-$OPT_TRAFFIC}
+    fi
+    hostkvers=${hostkvers:-host-$(uname -r)}
+    kvers=${kvers:-$(sshgw uname -r)}
+    test=$(basename $0 .sh)
+    for traffic in $traffics; do
+       dir="results/$hostkvers/$kvers/$traffic/$test"
+       mkdir -p $dir
+       script=$(echo $dir | sed -e 's/[^/]*/../g')/${test}.sh
+       cd $dir
+       if [[ ! "$OPT_PLOT_ONLY" ]]; then
+           echo "Working directory: $dir"
+           _measure
+       fi
+       if [[ ! "$OPT_PLOT_DISABLE" ]]; then
+           _plot
+       fi
+       cd - > /dev/null
+    done
 }
 
 test_end() {
     test_end_called=t
-    trap '' DEBUG
+    exit_ok=
     _run
+    exit_ok=t
 }
 
-exit() {
+_myexit() {
+    code=$?
+    cmd=$BASH_COMMAND
     if [[ ! "$test_end_called" ]]; then
        test_end_called=t
        error "bug in the test script: No test_end called"
     fi
+    if ! test -n "$exit_ok"; then
+       error "FATAL: Command '$cmd' exit with code $code"
+    fi
 }
 
-trap 'exit' EXIT
+trap '_myexit' EXIT